include windows.inc
include user32.inc
include kernel32.inc
include comctl32.inc
include shell32.inc
include ole32.inc
include comdlg32.inc


includelib user32.lib
includelib kernel32.lib
includelib comctl32.lib
includelib shell32.lib   
includelib ole32.lib
includelib comdlg32.lib

;Debug macros
include masm32.inc
include debug.inc
includelib masm32.lib
includelib debug.lib
;
DlgProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
InsertColumn	PROTO :DWORD
init_Wallet		PROTO :DWORD
	
	
.const

IDDone			equ	1							; 
IDQuit			equ	2							; quit button
IDD_TABTEST		equ 1000
IDC_TAB1		equ 1001

IDD_TAB1		equ 2000

IDD_TAB2		equ 3000

IDD_TAB3		equ 4000
IDC_SBR1		equ	1002						; status bar

;****			Menu	
IDM_FILE_EXIT 	equ	10001
IDM_FILE_SAVEDB	equ	10002
IDM_FILE_LOADDB	equ	10003
IDM_FILE_LOADSYS equ 10005
IDM_FILE_SAVESYS equ 10006

;****			Tab 1 page controls
IDC_STCTAB1 	equ	2002
IDC_GRP1 		equ	2001
IDC_DBPath 		equ	2003
IDC_BTNBrowse 	equ	2004
IDC_GRP2 		equ	2005
IDC_SetPass 	equ	2006
IDC_Pass 		equ	2007
IDC_STC1 		equ	2008
IDC_SetConfirm	equ	2009
IDC_BTNSave 	equ	2010
IDC_BTNAccept	equ	2011

;****			Tab 2 page controls
IDC_EDTWebsite	equ	3001
IDC_EDTURL		equ	3002
IDC_STC2		equ	3003
IDC_STC3		equ	3004
IDC_STC4		equ	3005
IDC_EDTUName	equ	3006
IDC_STC5		equ	3007
IDC_STC6		equ	3008
IDC_EDTPass		equ	3009
IDC_EDTRemark	equ	3010
IDC_GRP3		equ	3011
IDC_BTNAdd		equ	3012
IDC_BTNDel		equ	3013
IDC_GRP4		equ	3014
IDC_BTNUp		equ	3015
IDC_BTNDown		equ	3016
IDC_BTNTop		equ	3017
IDC_BTNBottom	equ	3018
IDC_STCCount	equ	3019

;****			Tab 3 page controls
IDD_TAB3 		equ	4000
IDC_LSVPass 	equ	4001


;*==============================================*
;*			Structure record declaration		*
;*==============================================*
Wallet_rec		struct
WebName			db	128 dup (?)	
URL				db	128 dup (?)					; URL name buffer
UserName		db	64 dup (?)					; user name
WebPass			db	64 dup (?)					; website password buffer
Remarks			db	128 dup (?)					; remark buffer
Wallet_rec 		ends

WRecSize		equ	sizeof (Wallet_rec) 		; wallet record size

;*==========================================*
;*			System record declaration		*
;*==========================================*
Sys_rec			struct
TotalRecords	dd	?							; total number of records
FilePath		db	128 dup (?)					; path to database
DBPass			db	128 dup (?)					; database password		
Sys_rec 		ends


;*==============================================*
;*			Initialized Data declaration		*
;*==============================================*
.data
AppName			db	"Password Wallet",0
TabTitle1      	db	" Configuration ",0
TabTitle2      	db 	" Password Entry ",0
TabTitle3      	db 	" Password List",0

DB_FileName		db	"Wallet.dat",0
Sys_FileName	db	"WSys.dat",0
WalletPath		db	"N:\RADAsm\Masm\Projects\Wallet",0

Msg_Browse		db	"Select folder for database",0
Msg_Folder		db	"Select A Folder",0
Msg_EnterPath	db	"Please enter path for database",0
Msg_PassDiff	db	"Please re-enter your password. Both are different",0
Msg_PassSame	db	"Password accepted",0
Msg_DiffLen		db	"String different length",0
Msg_SameLen		db	"String same length",0

Msg_WriteOErr	db	"Write Error: Opening file for write operation",0
Msg_WriteNErr	db	"Write Error: number of bytes written incorrect",0
Msg_WriteWErr	db	"Write Error: Error in saving file",0
Msg_WriteOK		db	"Database saved",0 

Msg_LoadErr		db	"Load Error: Unable to load database",0
Msg_LoadOK		db	"Database loaded into memory",0	

Msg_SysLdOK		db	"System record loaded",0
Msg_SysLdErr	db	"Error loading system record",0
Msg_SysWrOK		db	"System record saved",0
Msg_SysWrErr	db	"Error saving system record",0

Msg_InvData		db	"No valid website information entered. Please enter the data",0

Msg_Welcome		db	"Welcome to Wallet Manager, written by GS Tan, revision 0.01 Jan 2008",0

Msg_DupURL		db	"URL record already found. Insert into database?",0
Msg_NoAdd		db	"Current website information is not added into database",0

				;*====	Listview column names	====
Col_Website		db	"Website",0
Col_URL			db	"URL",0
Col_User		db	"Username",0
Col_Pass		db	"Password",0


;********************************************************
;*				Uninitialize data variables				*
;********************************************************
.data?
lvi					LV_ITEM	<?>

hInstance		dd 	?
hTab				dd ?
hTabDlg			dd 	3 dup(?)
SelTab			dd 	?
hFile			dd	?							; handle to file
i_byteread		dd	?							; file byte size
FileError		dd	?							; File error code
hStatus			dd	?							; status bar handle
hListView		dd	?							; handle for listview control
hHeader			dd	?							; handle for listview control
hWCount			dd	?							; handle to label record count control

;*====		Password variables	====
CPassWord		db	64 dup (?)					; confirm password memory

hEditPath		dd	?							; handle for path
hBtnBrowse		dd	?							; handle for Browse button
hBtnAccept		dd	?							; handle for accept password
hEd_Pass		dd	?							; handle for password edit control
hEd_Confirm		dd	?							; handle for confirm password edit control

;*====		System record buffer	====
WRecords		dd	?							; total number of records
FilePath		db	256 dup (?)					; file path buffer
PassWord		db	64 dup (?)					; password memory

FPath			db	255 dup (?)					; file path used
Msg_Buf			db	255 dup (?)					; buffer for display 

;*====		Tab 2 variables		====
Website			db	128 dup (?)					; website name buffer
URL				db	128 dup (?)					; URL name buffer
UserName		db	64 dup (?)					; user name
WebPass			db	64 dup (?)					; website password buffer
Remarks			db	128 dup (?)					; remark buffer

hWebsite		dd	?							; handle to website edit control
hURL			dd	?							; handle to URL edit control
hUserName		dd	?							; handle to user name edit control
hWebPass		dd	?							; handle to website password edit control
hRemark			dd	?							; handle to remark edit control
hSaveConf		dd	?							; handle to save configuration button

;*====		Database information	====
WCurIndex		dd	?							; current record index
WSrchIndex		dd	?							; search index record

WData			db	1024*WRecSize				; database for 1024 records

bChanged		db	?							; DB changed flag